package sun.security.krb5.internal.crypto;

import sun.security.krb5.KrbCryptoException;
import java.security.GeneralSecurityException;
import sun.security.krb5.internal.crypto.dk.AesDkCrypto;

public class Aes256
{
    private static final AesDkCrypto CRYPTO;
    
    private Aes256() {
    }
    
    public static byte[] stringToKey(char[] password, String salt, byte[] s2kparams) throws GeneralSecurityException {
        return Aes256.CRYPTO.stringToKey(password, salt, s2kparams);
    }
    
    public static int getChecksumLength() {
        return Aes256.CRYPTO.getChecksumLength();
    }
    
    public static byte[] calculateChecksum(byte[] baseKey, int usage, byte[] input, int start, int len) throws GeneralSecurityException {
        return Aes256.CRYPTO.calculateChecksum(baseKey, usage, input, start, len);
    }
    
    public static byte[] encrypt(byte[] baseKey, int usage, byte[] ivec, byte[] plaintext, int start, int len) throws GeneralSecurityException, KrbCryptoException {
        return Aes256.CRYPTO.encrypt(baseKey, usage, ivec, null, plaintext, start, len);
    }
    
    public static byte[] encryptRaw(byte[] baseKey, int usage, byte[] ivec, byte[] plaintext, int start, int len) throws GeneralSecurityException, KrbCryptoException {
        return Aes256.CRYPTO.encryptRaw(baseKey, usage, ivec, plaintext, start, len);
    }
    
    public static byte[] decrypt(byte[] baseKey, int usage, byte[] ivec, byte[] ciphertext, int start, int len) throws GeneralSecurityException {
        return Aes256.CRYPTO.decrypt(baseKey, usage, ivec, ciphertext, start, len);
    }
    
    public static byte[] decryptRaw(byte[] baseKey, int usage, byte[] ivec, byte[] ciphertext, int start, int len) throws GeneralSecurityException {
        return Aes256.CRYPTO.decryptRaw(baseKey, usage, ivec, ciphertext, start, len);
    }
    
    static {
        CRYPTO = new AesDkCrypto(256);
    }
}
